#include "geki5.h"
#include "extern.h"

//========================================
// ʬư
//========================================
RcHitEnum MoveMyShot(CharacterData *my)
{
  my->CntX += my->AddX;
  my->CntY += my->AddY;
  my->X = my->CntX >> 8;
  my->Y = my->CntY >> 8;
  if (my->Y < UP_TOP - my->Spr[my->FrameNo]->Image->Height ||
      my->Y > UP_BOTTOM ||
      my->X < UP_LEFT - my->Spr[my->FrameNo]->Image->Width ||
      my->X > UP_RIGHT) {
    (Root->MyShots) && Root->MyShots --;
    return RcHitDel;
  }
  return RcHitNone;
}

//========================================
// ʬ
//========================================
RcHitEnum HitMyShot(CharacterData *my, CharacterData *your)
{
  (Root->MyShots) && Root->MyShots --;
  return RcHitDel;
}

//========================================
// ʬåȺ
//========================================
void CreateMyWeaponShot(Sint16 x, Sint16 y, Uint16 dir)
{
  Cchr.Attr   = AttrMShot;
  Cchr.Target = AttrEnemy;
  Cchr.Cnt3   = 1;
  GetDirectionAdd(dir, &(Cchr.AddX), &(Cchr.AddY), 10);
  Cchr.X      = x;
  Cchr.Y      = y;
  Cchr.Spr    = PixMShot;
  CopyMyNew(MoveMyShot, HitMyShot, DrawImageFrame);
}

//========================================
// ʬư
//========================================
RcHitEnum MoveMy(CharacterData *my)
{
  static int mcnt = 0;
  Sint16 sx, sy, i;

  // ˰ư
  if (Root->Key & KRight)
    my->X += my->AddX;
  // ˰ư
  if (Root->Key & KLeft)
    my->X -= my->AddX;
  // ưϰϥå
  if (my->X < UP_LEFT)
    my->X = UP_LEFT;
  else if (my->X > UP_RIGHT - my->Spr[0]->Image->Width)
    my->X = UP_RIGHT - my->Spr[0]->Image->Width;
  // ե졼å
  my->FrameNo = 0;

  // ̵Ũ
  if (my->MoveFlag > 0) {
    if (my->MoveFlag > 20) {
      // ®
      if (my->MoveFlag % 2)
	my->FrameNo = 1;
    } else {
      // ٤
      if (my->MoveFlag % 4 == 0)
	my->FrameNo = 1;
    }
    // ̵Ũλå
    if (-- my->MoveFlag == 0)
      Root->My[0]->Chr.Target = AttrEnemy | AttrEShot | AttrItem;
  }

  // ȯ
  if ((Root->Key & KShot) && Root->MyShots < Root->MyShotsMax) {
    sx = my->X + (my->Spr[my->FrameNo]->Image->Width / 2) - 1;
    sy = my->Y + 10;
    //if (Root->MyShotPower == 0) {
      CreateMyWeaponShot(sx - (PixMShot[0]->Image->Width / 2), sy, 180);
      //} else {
      //  for (i = -12; i <= 12; i += 24)
      //CreateMyWeaponShot(sx + i - (PixMShot[0]->Image->Width / 2), sy, 180);
      //}
    Root->MyShots ++;
    Root->Key &= KShotMask;
  }
  return RcHitNone;
}

//========================================
// ʬ(ȯ)
//========================================
void ReCreateMy(void) {
  Root->My[0]->Chr.Attr    = AttrMy;
  Root->My[0]->Chr.Target  = AttrItem;
  Root->My[0]->Chr.MoveFlag= 2000 / FRAME_RATE;
  Root->My[0]->Chr.Spr     = PixMy;
  Root->My[0]->Chr.FrameNo = 0;
  Root->My[0]->Move        = MoveMy;
  Root->My[0]->Draw        = DrawImageFrame;
  Root->My[0]->Hit         = HitMy;
}

//========================================
// ʬȯ
//========================================
RcHitEnum MoveMyBomb(CharacterData *my)
{
  if (my->FrameNo < 9) { // ȯ
    my->FrameNo ++;
    return RcHitNone;
  } else {
    if (-- Root->Life >= 0) { // ĵ
      ReCreateMy();
    } else { // ĵʤ
      // ४С
      Root->Life = 0;
      Root->Cnt = 0;
      Root->MainFlag = MainGameOver;
      return RcHitDel;
    }
  }
  return RcHitNone;
}

//========================================
// ʬ
//========================================
RcHitEnum HitMy(CharacterData *my, CharacterData *your)
{
  if (your->Attr & AttrItem) { // ƥ
    KXL_PlaySound(SE_POW, KXL_SOUND_PLAY);
    if ((++ Root->MyPower) % 50 == 0) {
      Root->MyShotPower ++;
      Root->MyShotsMax ++;
    }
  } else if (my->MoveFlag == 0) { // ̵Ũʳȯ
    Root->My[0]->Chr.Attr    = AttrNone;
    Root->My[0]->Chr.Target  = AttrNone;
    Root->My[0]->Chr.Spr     = PixBomb;
    Root->My[0]->Chr.FrameNo = 0;
    Root->My[0]->Move        = MoveMyBomb;
    KXL_PlaySound(SE_BOMB, KXL_SOUND_PLAY);
  }
  return RcHitNone;
}

//========================================
// ʬ
//========================================
void CreateMy(void) {
  Uint16 i;

  for (i = 0; i < MAX_YOUR; i ++)
    Root->Your[i]->Chr.Active = False;
  for (i = 0; i < MAX_MY; i ++)
    Root->My[i]->Chr.Active = False;

  Root->MyNo = 1;
  Root->My[0]->Chr.Attr     = AttrMy;
  Root->My[0]->Chr.Target   = AttrItem;
  Root->My[0]->Chr.MoveFlag = 2000 / FRAME_RATE;
  Root->My[0]->Chr.Spr      = PixMy;
  Root->My[0]->Chr.X        = PIC_WIDTH / 2 - Root->My[0]->Chr.Spr[0]->Image->Width / 2;
  Root->My[0]->Chr.Y        = UP_BOTTOM - Root->My[0]->Chr.Spr[0]->Image->Height - 20;
  Root->My[0]->Chr.AddX     = 8;
  Root->My[0]->Chr.AddY     = 8;
  Root->My[0]->Chr.Active   = True;
  Root->My[0]->Chr.Cnt2     = 0;
  Root->My[0]->Chr.FrameNo  = 0;
  Root->My[0]->Chr.FrameMax = 2;
  Root->My[0]->Move         = MoveMy;
  Root->My[0]->Draw         = DrawImageFrame;
  Root->My[0]->Hit          = HitMy;
}
